#ifndef SCREENMODE_H
#define SCREENMODE_H

/**** REG_DISPCNT defines */

/**************************
* MODE 0                  *
* 4 available backgrounds *
* rotation or scaling     *
* or 256 colors           *
* 1024 tiles              *
**************************/
#define MODE_0 0x0

/*******************************************
* MODE 1                                   *
* Only background 0, 1 and 2 are available *
* Background 2 supports rotation/scaling   *
* 256 colors                               *
* Maximum 256 tiles                        *
*******************************************/
#define MODE_1 0x1

/********************************************
* MODE 2                                    *
* Only background 2 and 3 are available     *
* Both backgrounds support rotation/scaling *
* 256 colors                                *
* Maximum 256 tiles                         *
********************************************/
#define MODE_2 0x2

/*********************************
* MODE 3                         *
* Only background 2 is available *
* 240x160 pixels                 *
* 32768 colors                   *
*********************************/
#define MODE_3 0x3

/***********************************************************************
* MODE 4                                                               *
* Only background 2 is available                                       *
* 240x160 pixels                                                       *
* Supports double buffering                                            *
* 256 different color entries from a palette made up from 32768 colors *
***********************************************************************/
#define MODE_4 0x4

/*********************************
* MODE 5                         *
* Only background 2 is available *
* 160x128 pixels                 *
* Supports double buffering      *
* 32768 colors                   *
*********************************/
#define MODE_5 0x5

#define BACKBUFFER 0x10
#define H_BLANK_OAM 0x20 

#define OBJ_MAP_2D 0x0
#define OBJ_MAP_1D 0x40

#define FORCE_BLANK 0x80

#define BG0_ENABLE 0x100
#define BG1_ENABLE 0x200 
#define BG2_ENABLE 0x400
#define BG3_ENABLE 0x800
#define OBJ_ENABLE 0x1000 

#define WIN1_ENABLE 0x2000 
#define WIN2_ENABLE 0x4000
#define WINOBJ_ENABLE 0x8000

/* SetMode Macro */
#define SetMode(mode) REG_DISPCNT = (mode) 

/* vsync Macro */
#define vsync() while (REG_VCOUNT < 160);

#endif
